<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: BLEService.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">BLEService.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * BLEService.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Mar 25, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_BLESERVICE_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_BLESERVICE_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;sdkconfig.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#if defined(CONFIG_BT_ENABLED)</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;esp_gatts_api.h&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;BLECharacteristic.h&quot;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;BLEServer.h&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;BLEUUID.h&quot;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &quot;FreeRTOS.h&quot;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">class </span>BLEServer;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">class </span>BLECharacteristicMap {</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordtype">void</span> setByUUID(BLECharacteristic* pCharacteristic, <span class="keyword">const</span> <span class="keywordtype">char</span>* uuid);</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keywordtype">void</span> setByUUID(BLECharacteristic* pCharacteristic, BLEUUID uuid);</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordtype">void</span> setByHandle(uint16_t handle, BLECharacteristic* pCharacteristic);</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    BLECharacteristic* getByUUID(<span class="keyword">const</span> <span class="keywordtype">char</span>* uuid); </div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    BLECharacteristic* getByUUID(BLEUUID uuid);</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    BLECharacteristic* getByHandle(uint16_t handle);</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    BLECharacteristic* getFirst();</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    BLECharacteristic* getNext();</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    std::string toString();</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">void</span> handleGATTServerEvent(esp_gatts_cb_event_t event, esp_gatt_if_t gatts_if, esp_ble_gatts_cb_param_t* param);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    std::map&lt;BLECharacteristic*, std::string&gt; m_uuidMap;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    std::map&lt;uint16_t, BLECharacteristic*&gt; m_handleMap;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    std::map&lt;BLECharacteristic*, std::string&gt;::iterator m_iterator;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;};</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="keyword">class </span>BLEService {</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keywordtype">void</span>               addCharacteristic(BLECharacteristic* pCharacteristic);</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    BLECharacteristic* createCharacteristic(<span class="keyword">const</span> <span class="keywordtype">char</span>* uuid, uint32_t properties);</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    BLECharacteristic* createCharacteristic(BLEUUID uuid, uint32_t properties);</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">void</span>               dump();</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordtype">void</span>               executeCreate(BLEServer* pServer);</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordtype">void</span>               executeDelete();</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    BLECharacteristic* getCharacteristic(<span class="keyword">const</span> <span class="keywordtype">char</span>* uuid);</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    BLECharacteristic* getCharacteristic(BLEUUID uuid);</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    BLEUUID            getUUID();</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    BLEServer*         getServer();</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keywordtype">void</span>               start();</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keywordtype">void</span>               stop();</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    std::string        toString();</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    uint16_t           getHandle();</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    uint8_t            m_instId = 0;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    BLEService(<span class="keyword">const</span> <span class="keywordtype">char</span>* uuid, uint16_t numHandles);</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    BLEService(BLEUUID uuid, uint16_t numHandles);</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span>BLEServer;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span>BLEServiceMap;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span>BLEDescriptor;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span>BLECharacteristic;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span>BLEDevice;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    BLECharacteristicMap m_characteristicMap;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    uint16_t             m_handle;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    BLECharacteristic*   m_lastCreatedCharacteristic = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    BLEServer*           m_pServer = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    BLEUUID              m_uuid;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>  m_semaphoreCreateEvt = <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>(<span class="stringliteral">&quot;CreateEvt&quot;</span>);</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>  m_semaphoreDeleteEvt = <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>(<span class="stringliteral">&quot;DeleteEvt&quot;</span>);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>  m_semaphoreStartEvt  = <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>(<span class="stringliteral">&quot;StartEvt&quot;</span>);</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>  m_semaphoreStopEvt   = <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>(<span class="stringliteral">&quot;StopEvt&quot;</span>);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    uint16_t             m_numHandles;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    BLECharacteristic* getLastCreatedCharacteristic();</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keywordtype">void</span> handleGATTServerEvent(esp_gatts_cb_event_t event, esp_gatt_if_t gatts_if, esp_ble_gatts_cb_param_t* param);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keywordtype">void</span>               setHandle(uint16_t handle);</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="comment">//void               setService(esp_gatt_srvc_id_t srvc_id);</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;}; <span class="comment">// BLEService</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="preprocessor">#endif // CONFIG_BT_ENABLED</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_BLESERVICE_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classFreeRTOS_1_1Semaphore_html"><div class="ttname"><a href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a></div><div class="ttdef"><b>Definition:</b> FreeRTOS.h:31</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
